Index: ruby-2.5.9/test/date/test_date_parse.rb
===================================================================
--- ruby-2.5.9.orig/test/date/test_date_parse.rb
+++ ruby-2.5.9/test/date/test_date_parse.rb
@@ -1,6 +1,7 @@
 # frozen_string_literal: true
 require 'test/unit'
 require 'date'
+require 'timeout'
 
 class TestDateParse < Test::Unit::TestCase
 
@@ -823,6 +824,13 @@ class TestDateParse < Test::Unit::TestCa
 
     h = Date._iso8601('')
     assert_equal({}, h)
+
+    h = Date._iso8601(nil)
+    assert_equal({}, h)
+
+    h = Date._iso8601('01-02-03T04:05:06Z'.to_sym)
+    assert_equal([2001, 2, 3, 4, 5, 6, 0],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test__rfc3339
@@ -838,6 +846,13 @@ class TestDateParse < Test::Unit::TestCa
 
     h = Date._rfc3339('')
     assert_equal({}, h)
+
+    h = Date._rfc3339(nil)
+    assert_equal({}, h)
+
+    h = Date._rfc3339('2001-02-03T04:05:06Z'.to_sym)
+    assert_equal([2001, 2, 3, 4, 5, 6, 0],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test__xmlschema
@@ -920,6 +935,13 @@ class TestDateParse < Test::Unit::TestCa
 
     h = Date._xmlschema('')
     assert_equal({}, h)
+
+    h = Date._xmlschema(nil)
+    assert_equal({}, h)
+
+    h = Date._xmlschema('2001-02-03'.to_sym)
+    assert_equal([2001, 2, 3, nil, nil, nil, nil],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test__rfc2822
@@ -952,6 +974,13 @@ class TestDateParse < Test::Unit::TestCa
 
     h = Date._rfc2822('')
     assert_equal({}, h)
+
+    h = Date._rfc2822(nil)
+    assert_equal({}, h)
+
+    h = Date._rfc2822('Sat, 3 Feb 2001 04:05:06 UT'.to_sym)
+    assert_equal([2001, 2, 3, 4, 5, 6, 0],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test__httpdate
@@ -972,6 +1001,13 @@ class TestDateParse < Test::Unit::TestCa
 
     h = Date._httpdate('')
     assert_equal({}, h)
+
+    h = Date._httpdate(nil)
+    assert_equal({}, h)
+
+    h = Date._httpdate('Sat, 03 Feb 2001 04:05:06 GMT'.to_sym)
+    assert_equal([2001, 2, 3, 4, 5, 6, 0],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test__jisx0301
@@ -984,6 +1020,15 @@ class TestDateParse < Test::Unit::TestCa
     h = Date._jisx0301('S63.02.03')
     assert_equal([1988, 2, 3, nil, nil, nil, nil],
 		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.04.30')
+    assert_equal([2019, 4, 30, nil, nil, nil, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.05.01')
+    assert_equal([2019, 5, 1, nil, nil, nil, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('R01.05.01')
+    assert_equal([2019, 5, 1, nil, nil, nil, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
 
     h = Date._jisx0301('H13.02.03T04:05:06')
     assert_equal([2001, 2, 3, 4, 5, 6, nil],
@@ -998,8 +1043,54 @@ class TestDateParse < Test::Unit::TestCa
     assert_equal([2001, 2, 3, 4, 5, 6, 3600],
 		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
 
+    h = Date._jisx0301('H31.04.30T04:05:06')
+    assert_equal([2019, 4, 30, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.04.30T04:05:06,07')
+    assert_equal([2019, 4, 30, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.04.30T04:05:06Z')
+    assert_equal([2019, 4, 30, 4, 5, 6, 0],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.04.30T04:05:06.07+0100')
+    assert_equal([2019, 4, 30, 4, 5, 6, 3600],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+
+    h = Date._jisx0301('H31.05.01T04:05:06')
+    assert_equal([2019, 5, 1, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.05.01T04:05:06,07')
+    assert_equal([2019, 5, 1, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.05.01T04:05:06Z')
+    assert_equal([2019, 5, 1, 4, 5, 6, 0],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('H31.05.01T04:05:06.07+0100')
+    assert_equal([2019, 5, 1, 4, 5, 6, 3600],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+
+    h = Date._jisx0301('R01.05.01T04:05:06')
+    assert_equal([2019, 5, 1, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('R01.05.01T04:05:06,07')
+    assert_equal([2019, 5, 1, 4, 5, 6, nil],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('R01.05.01T04:05:06Z')
+    assert_equal([2019, 5, 1, 4, 5, 6, 0],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+    h = Date._jisx0301('R01.05.01T04:05:06.07+0100')
+    assert_equal([2019, 5, 1, 4, 5, 6, 3600],
+		 h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
+
     h = Date._jisx0301('')
     assert_equal({}, h)
+
+    h = Date._jisx0301(nil)
+    assert_equal({}, h)
+
+    h = Date._jisx0301('H13.02.03T04:05:06.07+0100'.to_sym)
+    assert_equal([2001, 2, 3, 4, 5, 6, 3600],
+      h.values_at(:year, :mon, :mday, :hour, :min, :sec, :offset))
   end
 
   def test_iso8601
@@ -1083,9 +1174,33 @@ class TestDateParse < Test::Unit::TestCa
     assert_equal(Date.new(2001,2,3), d)
     assert_equal(Date::ITALY + 10, d.start)
 
+    d = Date.jisx0301('H31.04.30', Date::ITALY + 10)
+    assert_equal(Date.new(2019,4,30), d)
+    assert_equal(Date::ITALY + 10, d.start)
+
+    d = Date.jisx0301('H31.05.01', Date::ITALY + 10)
+    assert_equal(Date.new(2019,5,1), d)
+    assert_equal(Date::ITALY + 10, d.start)
+
+    d = Date.jisx0301('R01.05.01', Date::ITALY + 10)
+    assert_equal(Date.new(2019,5,1), d)
+    assert_equal(Date::ITALY + 10, d.start)
+
     d = DateTime.jisx0301('H13.02.03T04:05:06+07:00', Date::ITALY + 10)
     assert_equal(DateTime.new(2001,2,3,4,5,6,'+07:00'), d)
     assert_equal(Date::ITALY + 10, d.start)
+
+    d = DateTime.jisx0301('H31.04.30T04:05:06+07:00', Date::ITALY + 10)
+    assert_equal(DateTime.new(2019,4,30,4,5,6,'+07:00'), d)
+    assert_equal(Date::ITALY + 10, d.start)
+
+    d = DateTime.jisx0301('H31.05.01T04:05:06+07:00', Date::ITALY + 10)
+    assert_equal(DateTime.new(2019,5,1,4,5,6,'+07:00'), d)
+    assert_equal(Date::ITALY + 10, d.start)
+
+    d = DateTime.jisx0301('R01.05.01T04:05:06+07:00', Date::ITALY + 10)
+    assert_equal(DateTime.new(2019,5,1,4,5,6,'+07:00'), d)
+    assert_equal(Date::ITALY + 10, d.start)
   end
 
   def test_given_string
@@ -1122,4 +1237,32 @@ class TestDateParse < Test::Unit::TestCa
     assert_equal(s0, s)
   end
 
+  def test_length_limit
+    assert_raise(ArgumentError) { Date._parse("1" * 1000) }
+    assert_raise(ArgumentError) { Date._iso8601("1" * 1000) }
+    assert_raise(ArgumentError) { Date._rfc3339("1" * 1000) }
+    assert_raise(ArgumentError) { Date._xmlschema("1" * 1000) }
+    assert_raise(ArgumentError) { Date._rfc2822("1" * 1000) }
+    assert_raise(ArgumentError) { Date._rfc822("1" * 1000) }
+    assert_raise(ArgumentError) { Date._jisx0301("1" * 1000) }
+
+    assert_raise(ArgumentError) { Date.parse("1" * 1000) }
+    assert_raise(ArgumentError) { Date.iso8601("1" * 1000) }
+    assert_raise(ArgumentError) { Date.rfc3339("1" * 1000) }
+    assert_raise(ArgumentError) { Date.xmlschema("1" * 1000) }
+    assert_raise(ArgumentError) { Date.rfc2822("1" * 1000) }
+    assert_raise(ArgumentError) { Date.rfc822("1" * 1000) }
+    assert_raise(ArgumentError) { Date.jisx0301("1" * 1000) }
+
+    assert_raise(ArgumentError) { DateTime.parse("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.iso8601("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.rfc3339("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.xmlschema("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.rfc2822("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.rfc822("1" * 1000) }
+    assert_raise(ArgumentError) { DateTime.jisx0301("1" * 1000) }
+
+    assert_raise(ArgumentError) { Date._parse("Jan " + "9" * 1000000) }
+    assert_raise(Timeout::Error) { Timeout.timeout(1) { Date._parse("Jan " + "9" * 1000000, limit: nil) } }
+  end
 end
Index: ruby-2.5.9/test/date/test_date_strftime.rb
===================================================================
--- ruby-2.5.9.orig/test/date/test_date_strftime.rb
+++ ruby-2.5.9/test/date/test_date_strftime.rb
@@ -406,6 +406,8 @@ class TestDateStrftime < Test::Unit::Tes
     assert_equal('S64.01.07', Date.parse('1989-01-07').jisx0301)
     assert_equal('H01.01.08', Date.parse('1989-01-08').jisx0301)
     assert_equal('H18.09.01', Date.parse('2006-09-01').jisx0301)
+    assert_equal('H31.04.30', Date.parse('2019-04-30').jisx0301)
+    assert_equal('R01.05.01', Date.parse('2019-05-01').jisx0301)
 
     %w(M06.01.01
        M45.07.29
@@ -414,7 +416,10 @@ class TestDateStrftime < Test::Unit::Tes
        S01.12.25
        S64.01.07
        H01.01.08
-       H18.09.01).each do |s|
+       H18.09.01
+       H31.04.30
+       R01.05.01
+    ).each do |s|
       assert_equal(s, Date.parse(s).jisx0301)
     end
 
Index: ruby-2.5.9/test/date/test_switch_hitter.rb
===================================================================
--- ruby-2.5.9.orig/test/date/test_switch_hitter.rb
+++ ruby-2.5.9/test/date/test_switch_hitter.rb
@@ -187,18 +187,18 @@ class TestSH < Test::Unit::TestCase
     d = Date.jd(Rational(2451944))
     assert_equal(2451944, d.jd)
     d = Date.jd(2451944.5)
-    assert_equal([2451944, 12], [d.jd, d.send('hour')])
+    assert_equal(2451944, d.jd)
     d = Date.jd(Rational('2451944.5'))
-    assert_equal([2451944, 12], [d.jd, d.send('hour')])
+    assert_equal(2451944, d.jd)
 
     d = Date.civil(2001, 2, 3.0)
     assert_equal([2001, 2, 3], [d.year, d.mon, d.mday])
     d = Date.civil(2001, 2, Rational(3))
     assert_equal([2001, 2, 3], [d.year, d.mon, d.mday])
     d = Date.civil(2001, 2, 3.5)
-    assert_equal([2001, 2, 3, 12], [d.year, d.mon, d.mday, d.send('hour')])
+    assert_equal([2001, 2, 3], [d.year, d.mon, d.mday])
     d = Date.civil(2001, 2, Rational('3.5'))
-    assert_equal([2001, 2, 3, 12], [d.year, d.mon, d.mday, d.send('hour')])
+    assert_equal([2001, 2, 3], [d.year, d.mon, d.mday])
 
     d = Date.ordinal(2001, 2.0)
     assert_equal([2001, 2], [d.year, d.yday])
@@ -266,10 +266,8 @@ class TestSH < Test::Unit::TestCase
   end
 
   def test_zone
-    d = Date.new(2001, 2, 3)
-    assert_equal(Encoding::US_ASCII, d.send(:zone).encoding)
     d = DateTime.new(2001, 2, 3)
-    assert_equal(Encoding::US_ASCII, d.send(:zone).encoding)
+    assert_equal(Encoding::US_ASCII, d.zone.encoding)
   end
 
   def test_to_s
@@ -534,7 +532,6 @@ class TestSH < Test::Unit::TestCase
     s = "\x04\x03u:\x01\x04Date\x01\v\x04\x03[\x01\x02i\x03\xE8i%T"
     d = Marshal.load(s)
     assert_equal(Rational(4903887,2), d.ajd)
-    assert_equal(0, d.send(:offset))
     assert_equal(Date::GREGORIAN, d.start)
   end
 
@@ -542,7 +539,6 @@ class TestSH < Test::Unit::TestCase
     s = "\x04\x06u:\tDate\x0F\x04\x06[\ai\x03\xE8i%T"
     d = Marshal.load(s)
     assert_equal(Rational(4903887,2), d.ajd)
-    assert_equal(0, d.send(:offset))
     assert_equal(Date::GREGORIAN, d.start)
   end
 
@@ -550,7 +546,6 @@ class TestSH < Test::Unit::TestCase
     s = "\x04\bu:\tDateP\x04\b[\bo:\rRational\a:\x0F@numeratori\x03\xCF\xD3J:\x11@denominatori\ai\x00o:\x13Date::Infinity\x06:\a@di\xFA"
     d = Marshal.load(s)
     assert_equal(Rational(4903887,2), d.ajd)
-    assert_equal(0, d.send(:offset))
     assert_equal(Date::GREGORIAN, d.start)
 
     s = "\x04\bu:\rDateTime`\x04\b[\bo:\rRational\a:\x0F@numeratorl+\b\xC9\xB0\x81\xBD\x02\x00:\x11@denominatori\x02\xC0\x12o;\x00\a;\x06i\b;\ai\ro:\x13Date::Infinity\x06:\a@di\xFA"
@@ -564,7 +559,6 @@ class TestSH < Test::Unit::TestCase
     s = "\x04\bU:\tDate[\bU:\rRational[\ai\x03\xCF\xD3Ji\ai\x00o:\x13Date::Infinity\x06:\a@di\xFA"
     d = Marshal.load(s)
     assert_equal(Rational(4903887,2), d.ajd)
-    assert_equal(Rational(0,24), d.send(:offset))
     assert_equal(Date::GREGORIAN, d.start)
 
     s = "\x04\bU:\rDateTime[\bU:\rRational[\al+\b\xC9\xB0\x81\xBD\x02\x00i\x02\xC0\x12U;\x06[\ai\bi\ro:\x13Date::Infinity\x06:\a@di\xFA"
Index: ruby-2.5.9/test/net/ftp/test_ftp.rb
===================================================================
--- ruby-2.5.9.orig/test/net/ftp/test_ftp.rb
+++ ruby-2.5.9/test/net/ftp/test_ftp.rb
@@ -62,6 +62,7 @@ class FTPTest < Test::Unit::TestCase
 
   def test_parse227
     ftp = Net::FTP.new
+    ftp.use_pasv_ip = true
     host, port = ftp.send(:parse227, "227 Entering Passive Mode (192,168,0,1,12,34)")
     assert_equal("192.168.0.1", host)
     assert_equal(3106, port)
@@ -80,6 +81,12 @@ class FTPTest < Test::Unit::TestCase
     assert_raise(Net::FTPProtoError) do
       ftp.send(:parse227, "227 ) foo bar (")
     end
+    ftp = Net::FTP.new
+    sock = OpenStruct.new
+    sock.peeraddr = [nil, nil, nil, "10.0.0.1"]
+    ftp.instance_variable_set(:@sock, sock)
+    host, port = ftp.send(:parse227, "227 Entering Passive Mode (192,168,0,1,12,34)")
+    assert_equal("10.0.0.1", host)
   end
 
   def test_parse228
Index: ruby-2.5.9/test/net/imap/test_imap.rb
===================================================================
--- ruby-2.5.9.orig/test/net/imap/test_imap.rb
+++ ruby-2.5.9/test/net/imap/test_imap.rb
@@ -127,6 +127,16 @@ class IMAPTest < Test::Unit::TestCase
         imap.disconnect
       end
     end
+
+    def test_starttls_stripping
+      starttls_stripping_test do |port|
+        imap = Net::IMAP.new("localhost", :port => port)
+        assert_raise(Net::IMAP::UnknownResponseError) do
+          imap.starttls(:ca_file => CA_FILE)
+        end
+        imap
+      end
+    end
   end
 
   def test_unexpected_eof
@@ -758,6 +768,27 @@ EOF
     ensure
       imap.disconnect if imap && !imap.disconnected?
     end
+  end
+
+  def starttls_stripping_test
+    server = create_tcp_server
+    port = server.addr[1]
+    @threads << Thread.start do
+      sock = server.accept
+      begin
+        sock.print("* OK test server\r\n")
+        sock.gets
+        sock.print("RUBY0001 BUG unhandled command\r\n")
+      ensure
+        sock.close
+        server.close
+      end
+    end
+    begin
+      imap = yield(port)
+    ensure
+      imap.disconnect if imap && !imap.disconnected?
+    end
   end
 
   def create_tcp_server
Index: ruby-2.5.9/test/rdoc/test_rdoc_rdoc.rb
===================================================================
--- ruby-2.5.9.orig/test/rdoc/test_rdoc_rdoc.rb
+++ ruby-2.5.9/test/rdoc/test_rdoc_rdoc.rb
@@ -366,6 +366,19 @@ class TestRDocRDoc < RDoc::TestCase
     end
   end
 
+  def test_remove_unparseable_CVE_2021_31799
+    omit 'for Un*x platforms' if Gem.win_platform?
+    temp_dir do
+      file_list = ['| touch evil.txt && echo tags']
+      file_list.each do |f|
+        FileUtils.touch f
+      end
+
+      assert_equal file_list, @rdoc.remove_unparseable(file_list)
+      assert_equal file_list, Dir.children('.')
+    end
+  end
+
   def test_setup_output_dir
     Dir.mktmpdir {|d|
       path = File.join d, 'testdir'
Index: ruby-2.5.9/test/rexml/formatter/test_default.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/formatter/test_default.rb
@@ -0,0 +1,17 @@
+module REXMLTests
+  class DefaultFormatterTest < Test::Unit::TestCase
+    def format(node)
+      formatter = REXML::Formatters::Default.new
+      output = +""
+      formatter.write(node, output)
+      output
+    end
+
+    class InstructionTest < self
+      def test_content_nil
+        instruction = REXML::Instruction.new("target")
+        assert_equal("<?target?>", format(instruction))
+      end
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/functions/test_base.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/functions/test_base.rb
@@ -0,0 +1,283 @@
+# frozen_string_literal: false
+require "test/unit/testcase"
+
+require "rexml/document"
+
+# TODO: Split me
+module REXMLTests
+  class FunctionsTester < Test::Unit::TestCase
+    include REXML
+
+    def setup
+      super
+      REXML::Functions.context = nil
+    end
+
+    def test_functions
+      # trivial text() test
+      # confuse-a-function
+      source = "<a>more <b id='1'/><b id='2'>dumb</b><b id='3'/><c/> text</a>"
+      doc = Document.new source
+      res = ""
+      XPath::each(doc.root, "text()") {|val| res << val.to_s}
+      assert_equal "more  text", res
+
+      res = XPath::first(doc.root, "b[last()]")
+      assert_equal '3', res.attributes['id']
+      res = XPath::first(doc.root, "b[position()=2]")
+      assert_equal '2', res.attributes['id']
+      res = XPath::first(doc.root, "*[name()='c']")
+      assert_equal "c", res.name
+    end
+
+    # Contributed by Mike Stok
+    def test_starts_with
+      source = <<-EOF
+        <foo>
+        <a href="mailto:a@b.c">a@b.c</a>
+        <a href="http://www.foo.com">http://www.foo.com</a>
+        </foo>
+      EOF
+      doc = Document.new source
+      mailtos = doc.elements.to_a("//a[starts-with(@href, 'mailto:')]")
+      assert_equal 1, mailtos.size
+      assert_equal "mailto:a@b.c", mailtos[0].attributes['href']
+
+      ailtos = doc.elements.to_a("//a[starts-with(@href, 'ailto:')]")
+      assert_equal 0, ailtos.size
+    end
+
+    def test_string_length
+      doc = Document.new <<-EOF
+        <AAA>
+        <Q/>
+        <SSSS/>
+        <BB/>
+        <CCC/>
+        <DDDDDDDD/>
+        <EEEE/>
+        </AAA>
+      EOF
+      assert doc, "create doc"
+
+      set = doc.elements.to_a("//*[string-length(name()) = 3]")
+      assert_equal 2, set.size, "nodes with names length = 3"
+
+      set = doc.elements.to_a("//*[string-length(name()) < 3]")
+      assert_equal 2, set.size, "nodes with names length < 3"
+
+      set = doc.elements.to_a("//*[string-length(name()) > 3]")
+      assert_equal 3, set.size, "nodes with names length > 3"
+    end
+
+    # Test provided by Mike Stok
+    def test_contains
+      source = <<-EOF
+        <foo>
+        <a href="mailto:a@b.c">a@b.c</a>
+        <a href="http://www.foo.com">http://www.foo.com</a>
+        </foo>
+      EOF
+      doc = Document.new source
+
+      [['o', 2], ['foo', 1], ['bar', 0]].each { |test|
+        search, expected = test
+        set = doc.elements.to_a("//a[contains(@href, '#{search}')]")
+        assert_equal expected, set.size
+      }
+    end
+
+    # Mike Stok and Sean Russell
+    def test_substring
+      # examples from http://www.w3.org/TR/xpath#function-substring
+      doc = Document.new('<test string="12345" />')
+
+      #puts XPath.first(d, 'node()[0 + 1]')
+      #d = Document.new("<a b='1'/>")
+      #puts XPath.first(d, 'a[0 mod 0]')
+      [ [1.5, 2.6, '234'],
+        [0, 3, '12'],
+        [0, '0 div 0', ''],
+        [1, '0 div 0', ''],
+        ['-42', '1 div 0', '12345'],
+                          ['-1 div 0', '1 div 0', '']
+      ].each { |start, length, expected|
+        set = doc.elements.to_a("//test[substring(@string, #{start}, #{length}) = '#{expected}']")
+        assert_equal 1, set.size, "#{start}, #{length}, '#{expected}'"
+      }
+    end
+
+    def test_substring_angrez
+      testString = REXML::Functions::substring_after("helloworld","hello")
+      assert_equal( 'world', testString )
+    end
+
+    def test_translate
+      source = <<-EOF
+      <doc>
+      <case name='w3c one' result='BAr' />        <!-- w3c -->
+      <case name='w3c two' result='AAA' />        <!-- w3c -->
+      <case name='alchemy' result="gold" />   <!-- mike -->
+      <case name='vbxml one' result='A Space Odyssey' />
+      <case name='vbxml two' result='AbCdEf' />
+      </doc>
+      EOF
+
+      doc = Document.new(source)
+
+      [ ['bar', 'abc', 'ABC', 'w3c one'],
+        ['--aaa--','abc-','ABC', 'w3c two'],
+        ['lead', 'dear language', 'doll groover', 'alchemy'],
+        ['A Space Odissei', 'i', 'y', 'vbxml one'],
+        ['abcdefg', 'aceg', 'ACE', 'vbxml two'],
+      ].each { |arg1, arg2, arg3, name|
+        translate = "translate('#{arg1}', '#{arg2}', '#{arg3}')"
+        set = doc.elements.to_a("//case[@result = #{translate}]")
+        assert_equal 1, set.size, translate
+        assert_equal name, set[0].attributes['name']
+      }
+    end
+
+    def test_name
+      d = REXML::Document.new("<a xmlns:x='foo'><b/><x:b/></a>")
+      assert_equal 1, d.root.elements.to_a('*[name() = "b"]').size
+      assert_equal 1, d.elements.to_a('//*[name() = "x:b"]').size
+    end
+
+    def test_local_name
+      d = REXML::Document.new("<a xmlns:x='foo'><b/><x:b/></a>")
+      assert_equal 2, d.root.elements.to_a('*[local_name() = "b"]').size
+      assert_equal 2, d.elements.to_a('//*[local_name() = "b"]').size
+    end
+
+    def test_substring2
+      doc = Document.new('<test string="12345" />')
+      assert_equal(1,doc.elements.to_a("//test[substring(@string,2)='2345']").size)
+    end
+
+    # Submitted by Kouhei
+    def test_floor_ceiling_round
+      source = "<a><b id='1'/><b id='2'/><b id='3'/></a>"
+      doc = REXML::Document.new(source)
+
+      id_1 = doc.elements["/a/b[@id='1']"]
+      id_2 = doc.elements["/a/b[@id='2']"]
+      id_3 = doc.elements["/a/b[@id='3']"]
+
+      good = {
+        "floor" => [[], [id_1], [id_2], [id_3]],
+        "ceiling" => [[id_1], [id_2], [id_3], []],
+        "round" => [[id_1], [id_2], [id_3], []]
+      }
+      good.each do |key, value|
+        (0..3).each do |i|
+          xpath = "//b[number(@id) = #{key}(#{i+0.5})]"
+          assert_equal(value[i], REXML::XPath.match(doc, xpath))
+        end
+      end
+
+      good["round"] = [[], [id_1], [id_2], [id_3]]
+      good.each do |key, value|
+        (0..3).each do |i|
+          xpath = "//b[number(@id) = #{key}(#{i+0.4})]"
+          assert_equal(value[i], REXML::XPath.match(doc, xpath))
+        end
+      end
+    end
+
+    # Submitted by Kou
+    def test_lang
+      d = Document.new(<<-XML)
+      <a xml:lang="en">
+      <b xml:lang="ja">
+      <c xml:lang="fr"/>
+      <d/>
+      <e xml:lang="ja-JP"/>
+      <f xml:lang="en-US"/>
+      </b>
+      </a>
+      XML
+
+      assert_equal(1, d.elements.to_a("//*[lang('fr')]").size)
+      assert_equal(3, d.elements.to_a("//*[lang('ja')]").size)
+      assert_equal(2, d.elements.to_a("//*[lang('en')]").size)
+      assert_equal(1, d.elements.to_a("//*[lang('en-us')]").size)
+
+      d = Document.new(<<-XML)
+      <root>
+      <para xml:lang="en"/>
+      <div xml:lang="en"><para/></div>
+      <para xml:lang="EN"/>
+      <para xml:lang="en-us"/>
+      </root>
+      XML
+
+      assert_equal(5, d.elements.to_a("//*[lang('en')]").size)
+    end
+
+    def test_ticket_60
+      document = REXML::Document.new("<a><b>A</b><b>1</b></a>")
+      assert_equal( "A", REXML::XPath.first(document, '//b[.="A"]').text )
+      assert_equal( "1", REXML::XPath.first(document, '//b[.="1"]').text )
+    end
+
+    def test_normalize_space
+      source = "<a><!--COMMENT A--><b><!-- COMMENT A --></b></a>"
+      doc = REXML::Document.new(source)
+      predicate = "string(.)=normalize_space('\nCOMMENT    \n A \n\n ')"
+      m = REXML::XPath.match(doc, "//comment()[#{predicate}]")
+      assert_equal( [REXML::Comment.new("COMMENT A")], m )
+    end
+
+    def test_normalize_space_strings
+      source = <<-XML
+<a><b>breakfast     boosts\t\t
+ 
+concentration   </b><c>
+Coffee beans
+ aroma
+
+
+
+</c><d>        Dessert
+ \t\t    after    dinner</d></a>
+      XML
+      normalized_texts = REXML::XPath.each(REXML::Document.new(source), "normalize-space(//text())").to_a
+      assert_equal([
+                     "breakfast boosts concentration",
+                     "Coffee beans aroma",
+                     "Dessert after dinner",
+                   ],
+                   normalized_texts)
+    end
+
+    def test_string_nil_without_context
+      doc = REXML::Document.new(<<~XML)
+      <?xml version="1.0" encoding="UTF-8"?>
+      <root>
+      <foo bar="baz"/>
+      <foo bar=""/>
+      </root>
+      XML
+
+      assert_equal([doc.root.elements[2]],
+                   REXML::XPath.match(doc,
+                                      "//foo[@bar=$n]",
+                                      nil,
+                                      {"n" => nil}))
+    end
+
+    def test_unregistered_method
+      doc = Document.new("<root/>")
+      assert_nil(XPath::first(doc.root, "to_s()"))
+    end
+
+    def test_nonexistent_function
+      doc = Document.new("<root><nonexistent/></root>")
+      # TODO: Maybe, this is not XPath spec behavior.
+      # This behavior must be reconsidered.
+      assert_equal(doc.root.elements[1],
+                   XPath::first(doc.root, "nonexistent()"))
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/functions/test_boolean.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/functions/test_boolean.rb
@@ -0,0 +1,75 @@
+# frozen_string_literal: false
+
+require "test/unit"
+require "rexml/document"
+require "rexml/functions"
+
+module REXMLTests
+  class TestFunctionsBoolean < Test::Unit::TestCase
+    def setup
+      REXML::Functions.context = nil
+    end
+
+    def test_true
+      assert_equal(true, REXML::Functions.boolean(true))
+    end
+
+    def test_false
+      assert_equal(false, REXML::Functions.boolean(false))
+    end
+
+    def test_integer_true
+      assert_equal(true, REXML::Functions.boolean(1))
+    end
+
+    def test_integer_positive_zero
+      assert_equal(false, REXML::Functions.boolean(0))
+    end
+
+    def test_integer_negative_zero
+      assert_equal(false, REXML::Functions.boolean(-0))
+    end
+
+    def test_float_true
+      assert_equal(true, REXML::Functions.boolean(1.1))
+    end
+
+    def test_float_positive_zero
+      assert_equal(false, REXML::Functions.boolean(-0.0))
+    end
+
+    def test_float_negative_zero
+      assert_equal(false, REXML::Functions.boolean(-0.0))
+    end
+
+    def test_float_nan
+      assert_equal(false, REXML::Functions.boolean(Float::NAN))
+    end
+
+    def test_string_true
+      assert_equal(true, REXML::Functions.boolean("content"))
+    end
+
+    def test_string_empty
+      assert_equal(false, REXML::Functions.boolean(""))
+    end
+
+    def test_node_set_true
+      root = REXML::Document.new("<root/>").root
+      assert_equal(true, REXML::Functions.boolean([root]))
+    end
+
+    def test_node_set_empty
+      assert_equal(false, REXML::Functions.boolean([]))
+    end
+
+    def test_nil
+      assert_equal(false, REXML::Functions.boolean(nil))
+    end
+
+    def test_context
+      REXML::Functions.context = {node: true}
+      assert_equal(true, REXML::Functions.boolean())
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/functions/test_local_name.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/functions/test_local_name.rb
@@ -0,0 +1,44 @@
+# frozen_string_literal: false
+
+require "test/unit"
+require "rexml/document"
+require "rexml/functions"
+
+module REXMLTests
+  class TestFunctionsLocalName < Test::Unit::TestCase
+    def setup
+      REXML::Functions.context = nil
+    end
+
+    def test_one
+      document = REXML::Document.new(<<-XML)
+<root xmlns:x="http://example.com/x/">
+  <x:child/>
+</root>
+      XML
+      node_set = document.root.children
+      assert_equal("child", REXML::Functions.local_name(node_set))
+    end
+
+    def test_multiple
+      document = REXML::Document.new(<<-XML)
+<root xmlns:x="http://example.com/x/">
+  <x:child1/>
+  <x:child2/>
+</root>
+      XML
+      node_set = document.root.children
+      assert_equal("child1", REXML::Functions.local_name(node_set))
+    end
+
+    def test_nonexistent
+      assert_equal("", REXML::Functions.local_name([]))
+    end
+
+    def test_context
+      document = REXML::Document.new("<root/>")
+      REXML::Functions.context = {node: document.root}
+      assert_equal("root", REXML::Functions.local_name())
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/functions/test_number.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/functions/test_number.rb
@@ -0,0 +1,38 @@
+# frozen_string_literal: false
+
+require "test/unit"
+require "rexml/document"
+require "rexml/functions"
+
+module REXMLTests
+  class TestFunctionsNumber < Test::Unit::TestCase
+    def setup
+      REXML::Functions.context = nil
+    end
+
+    def test_true
+      assert_equal(1, REXML::Functions.number(true))
+    end
+
+    def test_false
+      assert_equal(0, REXML::Functions.number(false))
+    end
+
+    def test_numeric
+      assert_equal(29, REXML::Functions.number(29))
+    end
+
+    def test_string_integer
+      assert_equal(100, REXML::Functions.number("100"))
+    end
+
+    def test_string_float
+      assert_equal(-9.13, REXML::Functions.number("-9.13"))
+    end
+
+    def test_node_set
+      root = REXML::Document.new("<root>100</root>").root
+      assert_equal(100, REXML::Functions.number([root]))
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/helper.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/helper.rb
@@ -0,0 +1,35 @@
+# frozen_string_literal: false
+
+require "test-unit"
+
+require "rexml/document"
+
+module Helper
+  module Fixture
+    def fixture_path(*components)
+      File.join(__dir__, "data", *components)
+    end
+  end
+
+  module Global
+    def suppress_warning
+      verbose = $VERBOSE
+      begin
+        $VERBOSE = nil
+        yield
+      ensure
+        $VERBOSE = verbose
+      end
+    end
+
+    def with_default_internal(encoding)
+      default_internal = Encoding.default_internal
+      begin
+        suppress_warning {Encoding.default_internal = encoding}
+        yield
+      ensure
+        suppress_warning {Encoding.default_internal = default_internal}
+      end
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/parse/test_attribute_list_declaration.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/parse/test_attribute_list_declaration.rb
@@ -0,0 +1,30 @@
+require "test/unit"
+require "core_assertions"
+
+require "rexml/document"
+
+module REXMLTests
+  class TestParseAttributeListDeclaration < Test::Unit::TestCase
+    include Test::Unit::CoreAssertions
+
+    def test_linear_performance_space
+      seq = [10000, 50000, 100000, 150000, 200000]
+      assert_linear_performance(seq, rehearsal: 10) do |n|
+        REXML::Document.new("<!DOCTYPE schema SYSTEM \"foo.dtd\" [<!ATTLIST " +
+                            " " * n +
+                            " root v CDATA #FIXED \"test\">]>")
+      end
+    end
+
+    def test_linear_performance_tab_and_gt
+      seq = [10000, 50000, 100000, 150000, 200000]
+      assert_linear_performance(seq, rehearsal: 10) do |n|
+        REXML::Document.new("<!DOCTYPE root [<!ATTLIST " +
+                            "\t" * n +
+                            "root value CDATA \"" +
+                            ">" * n +
+                            "\">]>")
+      end
+    end
+  end
+end
